Minimum Window Substring - Airbnb Interview Question - Leetcode 76

Sdílet
Vložit
  • čas přidán 27. 07. 2024
  • 🚀 neetcode.io/ - A better way to prepare for Coding Interviews
    🐦 Twitter: / neetcode1
    🥷 Discord: / discord
    🐮 Support the channel: / neetcode
    Code on Github: github.com/neetcode-gh/leetco...
    💡 CODING SOLUTIONS: • Coding Interview Solut...
    💡 DYNAMIC PROGRAMMING PLAYLIST: • House Robber - Leetco...
    🌲 TREE PLAYLIST: • Invert Binary Tree - D...
    💡 GRAPH PLAYLIST: • Course Schedule - Grap...
    💡 BACKTRACKING PLAYLIST: • Word Search - Backtrac...
    💡 LINKED LIST PLAYLIST: • Reverse Linked List - ...
    Problem Link: neetcode.io/problems/minimum-...
    0:00 - Read the problem
    1:15 - Drawing Brute Force
    5:55 - Drawing Linear Solution
    17:45 - Coding Solution
    leetcode 76
    This question was identified as an airbnb interview question from here: github.com/xizhengszhang/Leet...
    #airbnb #python #slidingwindow
    Disclosure: Some of the links above may be affiliate links, from which I may earn a small commission.
  • Věda a technologie

Komentáře • 287

  • @NeetCode
    @NeetCode  Před 3 lety +128

    🚀 neetcode.io/ - I created a FREE site to make interview prep a lot easier, hope it helps! ❤
    This one turned out longer than expected, recommend 1.5x speed

    • @thelookofdisapproval8234
      @thelookofdisapproval8234 Před 3 lety +13

      Lmao I've watched so many lectures on youtube, many require you see it at 1.5x or 2x
      this is the first time, I have seen the youtuber himself suggesting doing the same,
      thank you for the uploads
      also can you do a question on union find algo?

    • @brieflyfun
      @brieflyfun Před rokem

      I wonder if there's a problem in line 26~28. The "have" count is not balanced. Should we have the same == conditions as line 17?
      if s[l] in countT and windows[s[l]] == countT[s[l]]:
      have -= 1
      windows[s[l]] -= 1
      to make the count balanced. "have" is the number of unique characters that meets the required numbers.

    • @Axl124124
      @Axl124124 Před 11 měsíci +2

      to be honest if I meet you and I hear you talking at normal speed, I would think you have dementia or something. I watch all your videos at 2x speed.

  • @jackscott4829
    @jackscott4829 Před 2 lety +214

    I never thought I'd see the day I'd fully understand a Leetcode Hard problem in under a half hour. Bless you sir.

  • @srikrishnarohanmadiraju8688
    @srikrishnarohanmadiraju8688 Před 3 lety +151

    Beautiful..! The blackboard explanation, clean code, the naming conventions, everything is just beautiful. Thank you.

  • @srinadhp
    @srinadhp Před 2 lety +21

    as usual, your explanation makes a hard problem look simple! Thank you so much!

  • @trueworth638
    @trueworth638 Před 3 lety +16

    great video, you're helping out a ton for interviews! Your channel is too underrated

  • @tanaykamath1415
    @tanaykamath1415 Před rokem +1

    I love how he explains and codes stuff elegantly !

  • @SanketBhat7
    @SanketBhat7 Před 5 měsíci +3

    This is one of a very few hard leetcode problems that I solved without any help. But indeed this video dives to the depth of the concept, watching to understand what other ways I could have solved it. Thanks!!

  • @infinity-clips9414
    @infinity-clips9414 Před rokem +4

    The legend comes and make it a piece of cake as usual.
    Your explanations are way more on another level.
    thanks man.

  • @ChanChan-pg4wu
    @ChanChan-pg4wu Před 2 lety +42

    Likely the most difficult question for sliding window. Again, watched it 3 times. Thank you, Neet!

    • @Notezl
      @Notezl Před rokem +12

      wait till you try Sliding window Maximum.

    • @Haseebkhan-yd9ud
      @Haseebkhan-yd9ud Před rokem

      @@Notezl 😂

    • @Tyler-jd3ex
      @Tyler-jd3ex Před 10 měsíci +4

      I’m glad that somebody else had to watch it multiple times. Sometimes I just feel dumb, but I have to remind myself that these videos are prepared and Neetcode probably struggled with it himself at first.

    • @akagamishanks7991
      @akagamishanks7991 Před 7 měsíci +1

      tbh honest Sliding window Maximum way easier haahahah@@Notezl

  • @airysm
    @airysm Před 3 lety +59

    Thank you for these videos! I'm switching from java to python for interviews and these have been really helpful

    • @NeetCode
      @NeetCode  Před 3 lety +15

      Thanks! I'm really happy that they are helpful!

  • @roman_mf
    @roman_mf Před rokem +5

    Thanks to you and NeetCode 150 list, I was able to solve this hard problem on my own without peeking at your solution! The runtime sucked really bad, but it was nonetheless accepted. Hooray!

  • @kiddem9247
    @kiddem9247 Před rokem +48

    For your solution, in line 17 comparing both map counts:
    if c in countT and window[c] == countT[c]
    I had to replace == with

    • @re-think7693
      @re-think7693 Před rokem +1

      Thanks! This helps

    • @yaboyjz
      @yaboyjz Před rokem

      same here!

    • @brieflyfun
      @brieflyfun Před rokem +6

      "need" is number of unique characters in t, not total number of characters. I think the problem is in line 26~28, which should have the same == conditions as line 17.
      if s[l] in countT and windows[s[l]] == countT[s[l]]:
      have -= 1
      windows[s[l]] -= 1
      to make the count balanced. "have" is the number of unique characters that meets the required numbers.

    • @felixdeng9824
      @felixdeng9824 Před 8 měsíci +6

      In his solution, he set need = len(countT) instead of len(t), that makes the while loop( have == need) will execute with no errors. Of course we can set window[c]

    • @govindrai93
      @govindrai93 Před 8 měsíci +2

      thanks @felixdeng9824 that was the reason. in python len(dictionary) == number of keys. So the case of "aaa", the dictionary would be { "a": 3 } and the len(a) would be 1. That's why == works for neetcode!

  • @alejandrodardon7091
    @alejandrodardon7091 Před 2 lety

    Amazing video with a great efficient solution, despite the code being a little bit all over the place at first glance I could perfectly follow your explanation great job!

  • @hmanjun7260
    @hmanjun7260 Před rokem +6

    Nice. I figured out how we would need to slide the window, but was struggling with how to store it and check if it satisfies the t counts. This was the first leetcode hard I've tried and feel good that I got a majority of the idea down.

    • @SIAMEInekeidijdnen
      @SIAMEInekeidijdnen Před rokem +1

      I agree. It was not as hard to actually figure out what was needed to solve the problem, but then when it came to implementing the solution, it got really hard and confusing. It was probably because we were trying to implement the brute force approach.

  • @mingjuhe1514
    @mingjuhe1514 Před 2 lety

    Thanks bro ,I am keeping watching your video these days. I feel I am improving in a fast speed.

  • @DavidInga7
    @DavidInga7 Před rokem +9

    @NeetCode Thanks so much for the video! I enjoyed watching how you solved this problem. I wanted to point out that the Leetcode problem states that we are dealing with only the 26 lowercase characters in the English alphabet. As such, our hashmap would be a constant size. Therefore our hashmap would never grow to a size of 100 as stated. All your videos are awesome. I hope my comment is constructive and helpful!

    • @user-SerhijA
      @user-SerhijA Před 8 měsíci

      That's not the case. Even at the beginning of the video it is seen that letters are capital.

  • @mohamadilhamramadhan6354

    It tooks me 12 hours to solve hard problem for the first time lol. I even use a linked list haha. And the runtime is bad but at least pass the test.
    I always look at your solution after I try by myself and... I often learn something new. Thanks 👍

  • @gouravsingh9509
    @gouravsingh9509 Před 2 lety +4

    Thanks a lot for the amazing explanation with each video. It has been so useful to understand things.

  • @tomonkysinatree
    @tomonkysinatree Před 3 měsíci

    Glad you made this solution video. I felt like i was close but wasn't able to test all the test cases. My approach was slightly off by trying to perform the solution with a single hashmap. Made some of the conditionals/updating super confusing and complicated and would have not finished in a real interview.

  • @yuxuanc
    @yuxuanc Před 2 lety +1

    Best explanation ever for this question, thank you for the great work!

  • @Yuipser
    @Yuipser Před 2 lety +3

    Thanks for another greater video ! after watching your video on 567. Permutation in String, I could figure out solution for this by myself.
    ur videos are always very inspiring and helpful !
    also, just want to share how I handle the left position differently:
    1. keep the left pointing at a char in t,
    2. if countS[nums[l] ] > countT[nums[l] ], increase the left because we can shorten the substring by making left pointing at the next num in t
    these condition will make sure that redundant elements on the left are dropped before we calculate the len of current substring

    • @sar3388
      @sar3388 Před 29 dny

      Were you able to code it yourself?

  • @garitina987
    @garitina987 Před rokem

    Wow that was incredibly explained. Hats off once again.

  • @sravanikatasani6502
    @sravanikatasani6502 Před 3 lety +10

    Hello, Bob Ross!. Amazing explanation as always :)

  • @TheSSB007
    @TheSSB007 Před 3 lety +2

    Loved the explanation!!

  • @shriharihallur633
    @shriharihallur633 Před 3 lety +2

    Very well explained, Thanks!!

  • @vikhyatsharma5035
    @vikhyatsharma5035 Před 3 lety +1

    Thank you, loved the explanation

  • @RanjuRao
    @RanjuRao Před rokem +1

    Thank you for your detailed explanation on the approach!

  • @yinglll7411
    @yinglll7411 Před 2 lety +1

    Thank you for the explanation!

  • @linli7049
    @linli7049 Před 3 lety +1

    You are such a good trainer

  • @hoyinli7462
    @hoyinli7462 Před 2 lety

    finally you uploaded your code! thx

  • @bouzie8000
    @bouzie8000 Před 6 měsíci

    This was so so fun lol. You're doing the lord's work

  • @ishanpadalkar9072
    @ishanpadalkar9072 Před 5 měsíci

    I had this solved intuitively, in quadratic time i'm guessing which is why it was failing the last test case on Time. This is a great explanation 👍

  • @yangjiawenxu2319
    @yangjiawenxu2319 Před rokem

    It is very clear for a hard leetcode problem.

  • @arupdas2210
    @arupdas2210 Před 2 lety +12

    C++ Implementation of the above explanation:
    string minWindow(string s, string t) {
    if(t==""){
    return "";
    }
    unordered_map um;
    for(int i=0;i

  • @rishikeshjaadhav2405
    @rishikeshjaadhav2405 Před rokem

    Awesome explanation! Thank you!

  • @jegadheeswarank6290
    @jegadheeswarank6290 Před 4 měsíci +1

    Awesome! Now I am going to code this in Java 🙂

  • @SeifGneedy2
    @SeifGneedy2 Před rokem +1

    Great Explanation, Thanks for everything!
    a small note: if we checked the entire hashmap, it will also be in O(1) because we have just lowercase and uppercase characters (Just 52 entries in the hashmap).

    • @algopenne
      @algopenne Před 23 dny

      agreed, I think something like this works just as well (at least it passes on LC)
      class Solution:
      def minWindow(self, s: str, t: str) -> str:
      t_counts = {}
      w_counts = {} #window_counts
      for c in t:
      t_counts[c] = t_counts.get(c, 0) + 1
      w_counts[c] = 0

      l = 0
      r = 0
      def is_good_window():
      for c in t_counts:
      if w_counts[c] < t_counts[c]:
      return False
      return True

      curr_len = len(s) + 1
      res = ""
      while r < len(s):
      w_counts[s[r]] = w_counts.get(s[r], 0) + 1

      while is_good_window():
      if r - l + 1 < curr_len:
      curr_len = r - l + 1
      res = s[l:r+1]
      w_counts[s[l]] -= 1
      l += 1
      r += 1
      return res

  • @sumitsharma6738
    @sumitsharma6738 Před rokem +1

    398 ms done. Took me 40 minutes to do so. but now lets see optimised version too :)

  • @MP-ny3ep
    @MP-ny3ep Před 5 měsíci +1

    Phenomenal explanation !!!! Thank you sooo very much !!!

  • @MrTulkonas
    @MrTulkonas Před 12 dny

    I suggest an alternative solution, which I think it is far easier to understand and code.
    1. Start defining a goal dictionary (with counts of "t" string) and worst dictionary (with counts of "s" string) -> current solution.
    2. Check if solution valid (counts in goal smaller or equal to current solution) => solution exists, else return "".
    3. Initiate a while loop with pointer l, r = 0, len(s) -1
    3a If utmost left character not in goal, increase l.
    3b Elseif utmost left character in goal and its count in current solution bigger than in goal, increase l and reduce count in current solution by 1
    3c,3d elseif ... (analog for utmost right character)
    3e return s[l:r+1]
    4 return s[l:r+1]

  • @atulkumar-bb7vi
    @atulkumar-bb7vi Před rokem

    Very nicely explained the hard problem. Really liking your videos. Thanks for this...

  • @lomoyang3034
    @lomoyang3034 Před 2 lety +27

    Another issue. In your code, the window map also count the character which does not exist in T, which is different from what you explained in slides. AFAK, your implementation is different than what you explained, though both of them are sliding window.

    • @bas5rocker311
      @bas5rocker311 Před rokem +2

      no, I think the implementation matches the code. Try and pop from left. If the character popped is not in 't', it throws a key error

    • @amrutaj28
      @amrutaj28 Před rokem +1

      I was going to point out the same.
      In both push (for right char) and pop (for left char) places, we need to just push the chars that exist in t-map.
      And this code modification works perfectly according to his explanation.
      PS. Thank you so much Neetcode for this great video!

    • @hwang1607
      @hwang1607 Před 9 měsíci

      this is my modified solution using the explanation, the curr hashmap is a map of the chars in T all set to 0, and chars not in T are not added from S
      class Solution:
      def minWindow(self, s: str, t: str) -> str:
      tcount = collections.Counter(t)
      curr = {k : 0 for k in t}
      l = 0
      have = 0
      need = len(tcount)
      minlen = float('inf')
      res = [0,0]

      for r in range(len(s)):
      if s[r] in curr:
      curr[s[r]] += 1
      if curr[s[r]] == tcount[s[r]]:
      have += 1
      while have == need:
      if (r - l + 1) < minlen:
      minlen = min(minlen, r - l + 1)
      res = [l,r]

      if s[l] in curr:
      curr[s[l]] -= 1
      if curr[s[l]] < tcount[s[l]]:
      have -= 1
      l += 1

      if minlen == float('inf'):
      return ""

      l,r = res
      return s[l:r+1]

  • @aryanyadav3926
    @aryanyadav3926 Před 2 lety +1

    Wonderful explanation!

  • @mruduladdipalli5417
    @mruduladdipalli5417 Před rokem +3

    With new test case of s = "bbaa" , t = "aba", it's not going inside while loop because "need" end up to 3 and "have" end up with 2,
    Since we check for map values of currentChar, which is updating have to 3, but need is at 3, because of length of t, it has 3 as value
    so we need to update "need" = uniqueCharactersOf(t);
    which we can achieve using set

    • @davidmar8612
      @davidmar8612 Před rokem +1

      I made this change and it worked thank you!

  • @uvarajupdates4464
    @uvarajupdates4464 Před 5 měsíci +2

    Keep posting videos regularly brother❤

  • @vishnusunil9610
    @vishnusunil9610 Před 8 měsíci

    thank you for the crystal clear explanation and code

  • @feesabilillah101
    @feesabilillah101 Před 9 měsíci

    The best explanation hands down

  • @kafychannel
    @kafychannel Před rokem

    Thank you NeedCode I got the entire idea of your solution!

  • @danomov
    @danomov Před 18 dny

    To optimize our window shrinking process, I think we can store the index of the new valid value. This way, next time we can move our start point directly to the next valid value and begin counting from there.

  • @sastecoder3421
    @sastecoder3421 Před rokem

    Lord NeetCode SUPREME Teacher !!

  • @cathyhuang8557
    @cathyhuang8557 Před 3 lety +7

    Thank you very much~ It is really helpful~

  • @biswaMastAadmi
    @biswaMastAadmi Před 2 lety

    Enjoyed the solution !

  • @bostonlights2749
    @bostonlights2749 Před 11 měsíci +1

    I was asked this in an interview yesterday

  • @anjumanislamiachhatarpur7093

    Nice explanation. Appreciate your effort.

  • @hix0071
    @hix0071 Před 2 lety

    well done. very well presented. 10/10

  • @thesouthsidedev1812
    @thesouthsidedev1812 Před rokem

    This was a very well explained solution

  • @275phuongvy
    @275phuongvy Před 3 lety +1

    thank you. great explanation

  • @harshavardhanranger
    @harshavardhanranger Před 2 lety +5

    whenever I find your video for a question I'm looking for, happiness = float("inf") !!

  • @sports_op
    @sports_op Před rokem

    Whoa, it's something I'd never have come up with by myself 🔥

  • @lymmontijo87
    @lymmontijo87 Před 4 měsíci

    WOW! Thanks for the explanation.

  • @kchemutai3483
    @kchemutai3483 Před měsícem

    Best explanation ever. Thank you neetcode

  • @amitgupta1202
    @amitgupta1202 Před 12 dny

    you can check dictionary sizes if we treat absence as zero. Complexity remains same but less no variables

  • @shashwatkumar6965
    @shashwatkumar6965 Před 2 lety +2

    If String t has repeated characters, then instead of have+= 1 we can do have += countT[c] and similarly instead of have -= 1, we do have -= countT[s[l]]

  • @thinhnguyenvan7003
    @thinhnguyenvan7003 Před rokem +1

    Hi NeetCode. Your video is amazing and helped so much in some problems that i did not have any idea to solve.
    By the way, when you apply in GG, are there any other questions related about System Design or something like that?

  • @wangfred
    @wangfred Před rokem

    When it runs, it runs like Rolex, so intriguing and accurate! There are two windows actually: the l r and have need.

  • @mondayemmanuel191
    @mondayemmanuel191 Před 2 lety

    Great explanation.

  • @theresabarton858
    @theresabarton858 Před 3 měsíci

    Much simpler solution: keep incrementing the left pointer as long as the substr cond is satisfied.. Also don't worry about comparing the 2 dicts, its still O(1).
    def minWindow(self, s: str, t: str) -> str:
    cond = lambda c1, c2: all([c1.get(k, 0) >= c2[k] for k in c2])
    sCounts = defaultdict(int)
    tCounts = dict(Counter(t))
    minWindowSz = float('inf')
    minWindowIdx = 0, 0
    L = 0
    for R in range(len(s)):
    sCounts[s[R]] += 1
    while cond(sCounts, tCounts) and L 0:
    sCounts[s[L]] -= 1
    L += 1
    return s[minWindowIdx[0]:minWindowIdx[1]+1] if minWindowSz < float('inf') else ""

  • @chandrachurmukherjeejucse5816

    Great Explanation!!!

  • @chillsjiujitsu
    @chillsjiujitsu Před 5 měsíci

    Neetcode is the goat!!!

  • @imranimmu4714
    @imranimmu4714 Před rokem

    Great Explanation
    Thank you

  • @harishankarkarthik3570
    @harishankarkarthik3570 Před 5 měsíci

    I solved this by myself, before seeing this solution. And I checked here to know that it was the most optimal solution :)

  • @aadil4236
    @aadil4236 Před 2 lety

    ingenious explanation!!

  • @JulianBoilen
    @JulianBoilen Před 2 lety +25

    7:56 Comparing the maps It wouldn't be bounded by t, it would be bounded by the number of possible characters, which is 52, or O(1).

    • @milapshah1075
      @milapshah1075 Před 2 lety

      I agree code needs one modification where you count need

    • @sudhanshusingh-cy9wp
      @sudhanshusingh-cy9wp Před rokem

      this might be submitted, but in an interview, this solution will considered much much better, i think

  • @sucraloss
    @sucraloss Před 10 měsíci

    I was so close on this one! I didn't think of that have vs need thing you did so I only solved half the test cases because I moved the left pointer properly but only changed the min_window_size when the count in t matched the count in s, which failed cases where we had duplicates.
    I couldn't think of a quick way to compare that we have enough of each specific value in the "s" hashmap such that we could check to see if our window was smaller. I was thinking maybe you would just have to make a helper function to go through the "s" hashmap's keys and make sure you have at least enough of each letter to match the count in t, but making a single integer increment when you have enough for each key is smart.
    I didn't even bother implementing my hashmap count helper function because I figured I was missing some way of tracking the size of the s and t hashmap and didn't want to spend 20 minutes just to get to a TLE.
    *Edit: I actually did check to see how slow my helper function would be and it was 80% slower than NC's solution. So it could work to check through the hashmaps key by key each time, but it's super slow. Good to know I was really very close to solving this.

  • @rishabh05
    @rishabh05 Před měsícem

    Instead of maintaining a set for visited nodes, we can just mark a visited node as 0 and we can then skip it the next time. This spaces us the space complexity involved with the set.

  • @b9944236
    @b9944236 Před rokem

    Great explanations.

  • @MalushJ
    @MalushJ Před 11 dny

    since we're dealing with capital letters (assuming thats all we have to check) the maximum number of checks is 26, its not dependent on the size of t.

  • @arsahilar
    @arsahilar Před 8 měsíci

    Neatly Explained!!

  • @Goodm26
    @Goodm26 Před 2 měsíci

    The time complexity should be O(n + k) instead of O(n), where k is the length of t.
    This is because in the beginning of the code we iterate over t to count its letter frequency.

  • @zhengzuo5118
    @zhengzuo5118 Před 2 lety

    Very good explanation

  • @kareni7572
    @kareni7572 Před měsícem

    Thank you for showing why we need that extra variable on top of hashmap & also that it will only be updated if it is ==

  • @RajiurRahman1
    @RajiurRahman1 Před rokem +1

    Hey! Big fan here.
    Just wanted to point out, this code will fail for s= "bbaa" and t="aba" (Leetcode testcase).
    In line#17, you have the following (C# version)
    if (countT.find(c) != countT.end() && window[c] == countT[c])
    For the aforementioned test scenario, countT['a'] is 2, while looping through s, for the first time when it sees 'a', window[c] == countT[c] this part of the statement will become false, hence have will not be increased. After finishing the first for loop, count will be 3 and have will be 2. If there are 10 'a's in s and 10 'a's in t, the have will have 1 after the loop. Therefore it'll return an empty string "". Changing it to following will pass the case.
    window[c]

  • @joshstevens2779
    @joshstevens2779 Před rokem +7

    I didn't do this in Python but another language. There seems to be an issue with line 16. The condition should be checking if window[c]

    • @najwadafir217
      @najwadafir217 Před 11 měsíci +1

      yes, you're right! else, the test s = "aa" t = "aa" won't pass

    • @jey_n_code
      @jey_n_code Před 10 měsíci

      thats true, thank youuu!

    • @straightlegmusic5269
      @straightlegmusic5269 Před 9 měsíci

      Was watching this on the neetcode site, literally opened it up to scan the comments for this issue cause I was doing this with JS lol.

    • @cinimodmil
      @cinimodmil Před 8 měsíci

      thanks for this! so in this case, have represents the number of characters needed to build substring t? i.e., we take into account duplicates when counting too.

  • @miserablepile
    @miserablepile Před 3 měsíci +1

    I'm at a point where I draft up my approach, then watch Neet explain the approach to see how I did. Then I draft up the code on my whiteboard, then watch how Neet writes the code. Feelin good!

  • @xmnemonic
    @xmnemonic Před rokem +1

    It's a good solution, but I think it's very unlikely anyone could come up with the have, need variables in an interviewing first time seeing this problem. That is a very clever optimization.

  • @damirsharip604
    @damirsharip604 Před 10 měsíci

    You are the best of bests

  • @assaidy
    @assaidy Před měsícem

    great explanation

  • @irinabarreto5884
    @irinabarreto5884 Před 3 lety

    Thank you!

  • @satishrella4800
    @satishrella4800 Před 2 lety +1

    Thanks for your videos, actually you do a great explanation, I have one doubt about this problem what if we have two results and print the result lexicographically which is smaller. if possible can you add this part? Thanks in advance

  • @aakashs1806
    @aakashs1806 Před měsícem

    Great Video

  • @thisisnotok2100
    @thisisnotok2100 Před 9 měsíci

    I improved upon this by using a single hash map containing the amount of characters in the t string, and decrementing the value as it was encountered in s. As we closed the window, we would re increment back up. If all the values in the map were 0 or less, we knew we had a valid solution.

    • @sumeshbharathiramasamy8559
      @sumeshbharathiramasamy8559 Před 8 měsíci

      checking the whole map for 0 or less --> will take 0(m). In the video, the approach has 0(1) time complexity

  • @JanneSauvala
    @JanneSauvala Před 11 měsíci

    On line 10, it should be "have, need = 0, sum(countT.values())" because if a character is present more than once in t, then it is not enough to check the length of the dictionary (number of keys) but you would need to sum up the dict's values.

  • @fortuner1122
    @fortuner1122 Před 13 dny

    excellent solution

  • @andreytamelo1183
    @andreytamelo1183 Před 2 lety +1

    Thanks!

  • @AlessioPepe
    @AlessioPepe Před 3 měsíci

    I wan't able to figure out how to reduce complexity from O(n*k) to O(n). Thank you for explaining the trick so easily!

  • @HuyLe-tu4pj
    @HuyLe-tu4pj Před 5 měsíci

    good job bro

  • @anonymoussloth6687
    @anonymoussloth6687 Před 2 lety +2

    At 19:17 why is need set to size of countT? If t is "aab" then we would need 2 a and 1b right? But ur code will set need at 2

  • @aimie2837
    @aimie2837 Před 2 lety +3

    def was given this at google

  • @nightmarauder2909
    @nightmarauder2909 Před 2 lety +5

    you can use Counter(t) to avoid the first loop

  • @wuzi9657
    @wuzi9657 Před rokem +1

    Thank you for the video! It helps a lot! I think they might have updated the constraints. It is guaranteed that the length of s and t is >= 1 as of 11/3/22, so it is not necessary to check the edge case where t is empty now.